searchData={"items":[{"type":"module","title":"HSDiff","doc":"Provides a Hunt–Szymanski-based line diff:\n  1) Compute the LCS (Longest Common Subsequence) using the Hunt–Szymanski approach.\n  2) Build a diff result (eq/del/ins) from that LCS.\n\nTypically used for large lists of lines where changes are relatively sparse.\nThis version also handles cases where left/right differ in length or contain\nmultiple occurrences of the same line.","ref":"HSDiff.html"},{"type":"function","title":"HSDiff.build_diff/3","doc":"Build a [eq: [...], del: [...], ins: [...]] diff from `left`, `right`,\nand `lcs` lines, using pointer arithmetic with a `reduce_while` call.\n\nWe return `{:cont, {acc, i, j}}` to keep going,\nor `{:halt, {acc, i, j}}` if we detect the LCS line can't be found.\n\nAfter the reduce, we handle leftover lines in `left` or `right`.","ref":"HSDiff.html#build_diff/3"},{"type":"function","title":"HSDiff.diff/2","doc":"diff/2 entry point:\n\n    diff(left, right)\n\nIf `left` and `right` are strings, we split them by `\n` into lists of lines.\nIf `left` and `right` are already lists, we pass them along.","ref":"HSDiff.html#diff/2"},{"type":"function","title":"HSDiff.hunt_szymanski_lcs/2","doc":"Compute the LCS of two lists (commonly lines) via Hunt–Szymanski.\n\nReturns just the **list of common elements** in order.\nYou can then convert that LCS into a diff using `build_diff/3` or your own logic.","ref":"HSDiff.html#hunt_szymanski_lcs/2"},{"type":"function","title":"HSDiff.optimize/1","doc":"","ref":"HSDiff.html#optimize/1"},{"type":"function","title":"HSDiff.patch/2","doc":"","ref":"HSDiff.html#patch/2"},{"type":"module","title":"HSDiff.Optimize","doc":"","ref":"HSDiff.Optimize.html"},{"type":"function","title":"HSDiff.Optimize.optimize/1","doc":"Optimize the diff by:\n  - merging consecutive eq: blocks into eq: count\n  - merging consecutive del: blocks into del: count\n  - merging consecutive ins: blocks into a single ins: [lines...]\n\nExample input:\n    [\n      eq: [\"Line A\"],\n      del: [\"Line B\"],\n      ins: [\"Line B changed\"],\n      eq: [\"Line C\", \"Line D\"],\n      del: [\"Line E\"],\n      ins: [\"Line E new\"],\n      eq: [\"Line F\"]\n    ]\n\nbecomes:\n    [\n      eq: 1,\n      del: 1,\n      ins: [\"Line B changed\"],\n      eq: 2,\n      del: 1,\n      ins: [\"Line E new\"],\n      eq: 1\n    ]","ref":"HSDiff.Optimize.html#optimize/1"},{"type":"module","title":"HSDiff.Patch","doc":"Applies a diff ([eq:, del:, ins:]) to an old text, producing the new text.\n\nIf the old text is a string, we return a **string** (with lines joined by \"\n\").\nIf the old text is a list of lines, we return a **list of lines**.","ref":"HSDiff.Patch.html"},{"type":"function","title":"HSDiff.Patch.patch/2","doc":"Patches the `old_text` with the given `diff`.\n\n- If `old_text` is a string, returns a **string**.\n- If `old_text` is a list of lines, returns a list of lines.","ref":"HSDiff.Patch.html#patch/2"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}